<?php

/**
 * @file
 * Hooks provided by the followup module.
 */

/**
 * @addtogroup hooks
 * @{
 */

/**
 * Allow modules to override a follow-up record before saving it.
 *
 * @param $node
 *   The node that triggered this followup-record
 * @param $record
 *   The follow-up record.
 */
function hook_followup_record_save($node, &$record) {
  // If node is created after target date, set follow-up record to 'cancelled'
  if ($node->created >= $record['target_date']) {
    $record['status'] = 'cancelled';
  }
}

/**
 * @} End of "addtogroup hooks".
 */
